/*
 * Prerelease License - for engineering feedback and testing purposes
 * only. Not for sale.
 *
 * File: fuel_rate_control.h
 *
 * Code generated for Simulink model 'fuel_rate_control'.
 *
 * Model version                  : 1.742
 * Simulink Coder version         : 9.3 (R2020a) 18-Nov-2019
 * C/C++ source code generated on : Wed Nov 27 12:21:15 2019
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Specified
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_fuel_rate_control_h_
#define RTW_HEADER_fuel_rate_control_h_
#ifndef fuel_rate_control_COMMON_INCLUDES_
# define fuel_rate_control_COMMON_INCLUDES_
#include "rtwtypes.h"
#endif                                 /* fuel_rate_control_COMMON_INCLUDES_ */

#include "fuel_rate_control_types.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

/* Block signals (default storage) */
typedef struct {
  EngSensors es_o;                     /* '<S1>/control_logic' */
  sld_FuelModes fuel_mode;             /* '<S1>/control_logic' */
  struct {
    uint_T O2_normal:1;                /* '<S1>/control_logic' */
  } bitsForTID0;
} BlockIO;

/* Block states (default storage) for system '<Root>' */
typedef struct {
  real32_T DiscreteIntegrator_DSTATE;  /* '<S2>/Discrete Integrator' */
  real32_T ThrottleTransient_states;   /* '<S2>/Throttle Transient' */
  real32_T DiscreteFilter_states;      /* '<S14>/Discrete Filter' */
  real32_T DiscreteFilter_states_i;    /* '<S13>/Discrete Filter' */
  uint16_T temporalCounter_i1;         /* '<S1>/control_logic' */
  uint8_T is_active_c1_fuel_rate_control;/* '<S1>/control_logic' */
  uint8_T is_O2;                       /* '<S1>/control_logic' */
  uint8_T is_active_O2;                /* '<S1>/control_logic' */
  uint8_T is_A;                        /* '<S1>/control_logic' */
  uint8_T is_Pressure;                 /* '<S1>/control_logic' */
  uint8_T is_active_Pressure;          /* '<S1>/control_logic' */
  uint8_T is_Throttle;                 /* '<S1>/control_logic' */
  uint8_T is_active_Throttle;          /* '<S1>/control_logic' */
  uint8_T is_Speed;                    /* '<S1>/control_logic' */
  uint8_T is_active_Speed;             /* '<S1>/control_logic' */
  uint8_T is_Fail;                     /* '<S1>/control_logic' */
  uint8_T is_active_Fail;              /* '<S1>/control_logic' */
  uint8_T is_Multi;                    /* '<S1>/control_logic' */
  uint8_T is_Fueling_Mode;             /* '<S1>/control_logic' */
  uint8_T is_active_Fueling_Mode;      /* '<S1>/control_logic' */
  uint8_T is_Fuel_Disabled;            /* '<S1>/control_logic' */
  uint8_T is_Running;                  /* '<S1>/control_logic' */
  uint8_T was_Running;                 /* '<S1>/control_logic' */
  uint8_T is_Low_Emissions;            /* '<S1>/control_logic' */
  uint8_T was_Low_Emissions;           /* '<S1>/control_logic' */
  uint8_T is_Rich_Mixture;             /* '<S1>/control_logic' */
} D_Work;

/* Constant parameters (default storage) */
typedef struct {
  /* Computed Parameter: RampRateKi_tableData
   * Referenced by: '<S2>/Ramp Rate Ki'
   */
  real32_T RampRateKi_tableData[36];

  /* Computed Parameter: RampRateKi_bp01Data
   * Referenced by: '<S2>/Ramp Rate Ki'
   */
  real32_T RampRateKi_bp01Data[6];

  /* Computed Parameter: RampRateKi_bp02Data
   * Referenced by: '<S2>/Ramp Rate Ki'
   */
  real32_T RampRateKi_bp02Data[6];

  /* Computed Parameter: PressureEstimation_tableData
   * Referenced by: '<S7>/Pressure Estimation'
   */
  real32_T PressureEstimation_tableData[306];

  /* Pooled Parameter (Expression: SpeedVect)
   * Referenced by:
   *   '<S2>/Pumping Constant'
   *   '<S7>/Pressure Estimation'
   *   '<S9>/Throttle Estimation'
   */
  real32_T pooled1[18];

  /* Pooled Parameter (Expression: ThrotVect)
   * Referenced by:
   *   '<S7>/Pressure Estimation'
   *   '<S8>/Speed Estimation'
   */
  real32_T pooled2[17];

  /* Computed Parameter: ThrottleEstimation_tableData
   * Referenced by: '<S9>/Throttle Estimation'
   */
  real32_T ThrottleEstimation_tableData[342];

  /* Computed Parameter: SpeedEstimation_tableData
   * Referenced by: '<S8>/Speed Estimation'
   */
  real32_T SpeedEstimation_tableData[323];

  /* Pooled Parameter (Expression: PressVect)
   * Referenced by:
   *   '<S2>/Pumping Constant'
   *   '<S8>/Speed Estimation'
   *   '<S9>/Throttle Estimation'
   */
  real32_T pooled3[19];

  /* Computed Parameter: PumpingConstant_tableData
   * Referenced by: '<S2>/Pumping Constant'
   */
  real32_T PumpingConstant_tableData[342];

  /* Computed Parameter: RampRateKi_maxIndex
   * Referenced by: '<S2>/Ramp Rate Ki'
   */
  uint32_T RampRateKi_maxIndex[2];

  /* Computed Parameter: PressureEstimation_maxIndex
   * Referenced by: '<S7>/Pressure Estimation'
   */
  uint32_T PressureEstimation_maxIndex[2];

  /* Pooled Parameter (Expression: )
   * Referenced by:
   *   '<S2>/Pumping Constant'
   *   '<S9>/Throttle Estimation'
   */
  uint32_T pooled8[2];

  /* Computed Parameter: SpeedEstimation_maxIndex
   * Referenced by: '<S8>/Speed Estimation'
   */
  uint32_T SpeedEstimation_maxIndex[2];
} ConstParam;

/* External inputs (root inport signals with default storage) */
typedef struct {
  EngSensors sensors;                  /* '<Root>/sensors' */
} ExternalInputs;

/* External outputs (root outports fed by signals with default storage) */
typedef struct {
  real32_T fuel_rate;                  /* '<Root>/fuel_rate' */
} ExternalOutputs;

/* Real-time Model Data Structure */
struct tag_RTM {
  const char_T * volatile errorStatus;
};

/* Block signals (default storage) */
extern BlockIO rtB;

/* Block states (default storage) */
extern D_Work rtDWork;

/* External inputs (root inport signals with default storage) */
extern ExternalInputs rtU;

/* External outputs (root outports fed by signals with default storage) */
extern ExternalOutputs rtY;

/* Constant parameters (default storage) */
extern const ConstParam rtConstP;

/* Model entry point functions */
extern void fuel_rate_control_initialize(void);
extern void fuel_rate_control_step(void);

/* Real-time Model object */
extern RT_MODEL *const rtM;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Note that this particular code originates from a subsystem build,
 * and has its own system numbers different from the parent model.
 * Refer to the system hierarchy for this subsystem below, and use the
 * MATLAB hilite_system command to trace the generated code back
 * to the parent model.  For example,
 *
 * hilite_system('msldemo_fuelsys_initial/fuel_rate_control')    - opens subsystem msldemo_fuelsys_initial/fuel_rate_control
 * hilite_system('msldemo_fuelsys_initial/fuel_rate_control/Kp') - opens and selects block Kp
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'msldemo_fuelsys_initial'
 * '<S1>'   : 'msldemo_fuelsys_initial/fuel_rate_control'
 * '<S2>'   : 'msldemo_fuelsys_initial/fuel_rate_control/airflow_calc'
 * '<S3>'   : 'msldemo_fuelsys_initial/fuel_rate_control/control_logic'
 * '<S4>'   : 'msldemo_fuelsys_initial/fuel_rate_control/fuel_calc'
 * '<S5>'   : 'msldemo_fuelsys_initial/fuel_rate_control/validate_sample_time'
 * '<S6>'   : 'msldemo_fuelsys_initial/fuel_rate_control/airflow_calc/Enumerated Constant'
 * '<S7>'   : 'msldemo_fuelsys_initial/fuel_rate_control/control_logic/Pressure.map_estimate'
 * '<S8>'   : 'msldemo_fuelsys_initial/fuel_rate_control/control_logic/Speed.speed_estimate'
 * '<S9>'   : 'msldemo_fuelsys_initial/fuel_rate_control/control_logic/Throttle.throttle_estimate'
 * '<S10>'  : 'msldemo_fuelsys_initial/fuel_rate_control/fuel_calc/feedforward_fuel_rate'
 * '<S11>'  : 'msldemo_fuelsys_initial/fuel_rate_control/fuel_calc/switchable_compensation'
 * '<S12>'  : 'msldemo_fuelsys_initial/fuel_rate_control/fuel_calc/switchable_compensation/disabled_mode'
 * '<S13>'  : 'msldemo_fuelsys_initial/fuel_rate_control/fuel_calc/switchable_compensation/low_mode'
 * '<S14>'  : 'msldemo_fuelsys_initial/fuel_rate_control/fuel_calc/switchable_compensation/rich_mode'
 * '<S15>'  : 'msldemo_fuelsys_initial/fuel_rate_control/validate_sample_time/CheckRange'
 */

/*-
 * Requirements for '<Root>': fuel_rate_control
 */
#endif                                 /* RTW_HEADER_fuel_rate_control_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
